function GraphInit(container_id, canvas_id) {
    $('#'+container_id).append('<div id="'+canvas_id+'" style="width: 500px; height: 500px;">');
}

function GraphDraw(canvas_id , filename, callback) {

    Plotly.d3.xml(filename, function(error, xmlRoot) {

        var place = xmlRoot.getElementsByTagName("position");

        var data = {
                x:[],
                y:[],
                z:[],
                mode: 'markers',
                marker: {
                    color:'rgb(255,0,0)',
                    size: 2,
                    symbol: 'circle',
                    opacity: 0.8},
                type: 'scatter3d',
                text:[],
            };

        for(var i=0; i<place.length; i++) {
            var xmlName = place.item(i);
            data.x.push(Number(xmlName.getAttribute("x")));
            data.y.push(Number(xmlName.getAttribute("y")));
            data.z.push(Number(xmlName.getAttribute("z")));
            data.text.push("id: "+xmlName.getAttribute("id"));
        }

        var range = [_.max(data.x)-_.min(data.x), _.max(data.y)-_.min(data.y), _.max(data.z)-_.min(data.z)];
        var maxRange = _.max(range);
        if (maxRange > 0) { range = [ range[0]/maxRange, range[1]/maxRange, range[2]/maxRange ]; }
console.log("@@range="+range);
        var layout = {
            showlegend: false,
            scene: {
            	aspectratio: {
                    x: range[0],
                    y: range[1],
                    z: range[2]
                },
                camera: {
                    eye: { x: 1.2, y: -1.2, z: 1.2 },
                },
            },
            margin: { l: 0, r: 0, b: 0, t: 0 }
        };

        Plotly.newPlot(canvas_id, [data], layout);
    });
}
